import java.io.*;
import org.w3c.tidy.*;

public class ConvertBadHTMLToGood
{
	public static void main(String args[]) throws Exception
	{
		if(args.length != 2)
		{
			usage();
			System.exit(1);
		}

		ConvertBadHTMLToGood conv = new ConvertBadHTMLToGood(new FileReader(args[0]));

		BufferedReader br = new BufferedReader(conv.doConvert());
		PrintWriter pw = new PrintWriter(new FileWriter(new File(args[1])), true);

		String line;

		while((line = br.readLine()) != null)
		{
			pw.println(line);
			pw.flush();
		}

		br.close();
		pw.close();
	}

	static void usage()
	{
		System.out.println("ConvertBadHTMLToGood <in-file> <out-file>");
	}

	
	Reader inReader;

	public ConvertBadHTMLToGood(Reader r)
	{
		if(r == null)
		{
			throw new IllegalArgumentException();
		}

		inReader = r;
	}

	public Reader doConvert() throws IOException
	{
		Tidy tidy = new Tidy();
		tidy.setXmlOut(true);
		tidy.setErrout(new PrintWriter(new StringWriter()));

		BufferedReader br = new BufferedReader(inReader);
		StringBuffer sb = new StringBuffer();
		String line;

		while((line = br.readLine()) != null)
		{
			sb.append(line);
			sb.append("\n");
		}

		ByteArrayInputStream bais = new ByteArrayInputStream(sb.toString().getBytes("US-ASCII"));
		ByteArrayOutputStream baos = new ByteArrayOutputStream();

		tidy.parse(bais, baos);
		FixEntities fe = new FixEntities(baos.toString());

		return(fe.getFixedReader());
	}
}