import java.io.*;
import java.util.*;
import com.sonalb.Utils;

public class FixEntities
{
	private Reader ir = null;
	private String s = null;

	public FixEntities(Reader ir)
	{
		if(ir == null)
		{
			throw new IllegalArgumentException("Null InputStream");
		}

		this.ir = ir;
	}

	public FixEntities(String str)
	{
		if(str == null)
		{
			throw new IllegalArgumentException("Null String");
		}

		this.s = str;
	}

	public Reader getFixedReader() throws IOException
	{
		if(s == null)
		{
			StringBuffer inBuff = new StringBuffer();
			int ch;

			while((ch = ir.read()) != -1)
			{
				inBuff.append((char) ch);
			}

			s = inBuff.toString();
		}

		StringTokenizer st = new StringTokenizer(s,"<>",true);

		String top, mid, bot;
		StringBuffer nuked = new StringBuffer();

		top = mid = bot = new String();

		boolean bInsideScript = false;
		boolean bDoReplace = false;

		while(st.hasMoreTokens())
		{
			top = mid;
			mid = bot;
			bot = st.nextToken();

			if(">".equals(top.trim()) && "<".equals(bot.trim()) && !"".equals(mid.trim()))
			{
				bDoReplace = true;
			}

			if(bot.toLowerCase().trim().equals("/script"))
			{
				bInsideScript = false;
			}

			if(bInsideScript)
			{
				bDoReplace = true;
			}

			if(bDoReplace)
			{
				mid = doReplace(mid);
				bDoReplace = false;
			}
			nuked.append(mid);

			if(top.toLowerCase().trim().startsWith("script"))
			{
				bInsideScript = true;
			}
		}

		nuked.append(bot);

		return(new StringReader(nuked.toString()));
	}

	private static String doReplace(String s)
	{
		s = Utils.replaceAll(s, "\"", "&quot;", false);
		s = Utils.replaceAll(s, "&nbsp;", " ", false);
		s = Utils.replaceAll(s, "&amp;", "&", false);
		s = Utils.replaceAll(s, "&", "&amp;", false);
		s = Utils.replaceAll(s, "<", "&lt;", false);
		s = Utils.replaceAll(s, ">", "&gt;", false);

		return(s);
	}
}