import java.io.*;
import java.net.*;
import java.util.*;

import com.sonalb.net.http.cookie.*;
import com.sonalb.net.http.*;

import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import org.w3c.dom.*;

public class HotmailChecker
{
	public static void main(String args[]) throws Exception
	{
		if(args.length != 2)
		{
			usage();
			System.exit(0);
		}

		String uname = args[0];
		String pass = args[1];
		HotmailChecker hmc = new HotmailChecker(uname,pass);
		
		if(!hmc.doLogin())
		{
			System.out.println("Could not login to Hotmail.");
			System.exit(0);
		}

		Vector newMessages = hmc.getNewMessages();

		if(newMessages == null)
		{
			System.out.println("No NEW Messages.");
			return;
		}

		System.out.println("You have " + newMessages.size() + " NEW Messages");
		System.out.println("---------------------------------------------");
		Iterator iter = newMessages.iterator();
		HMMessage hm;

		while(iter.hasNext())
		{
			hm = (HMMessage) iter.next();
			System.out.println("     From: " + hm.getFrom());
			System.out.println("  Subject: " + hm.getSubject());
			System.out.println("Sent Date: " + hm.getSentDate());
			System.out.println("---------------------------------------------");
		}
	}

	static void usage()
	{
		System.out.println("\nUsage: java HotmailChecker <Hotmail Username> <Password>");
	}

	String user;
	String pw;
	boolean bLoggedIn = false;
	CookieJar cj;
	String aValue;
	URL mainUrl;

	public HotmailChecker(String username, String password)
	{
		if(username == null || password == null || "".equals(username) || "".equals(password))
		{
			throw new IllegalArgumentException();
		}

		user = username;
		pw = password;
	}

	public boolean doLogin() throws Exception
	{
		if(bLoggedIn)
		{
			throw new IllegalStateException("Already Logged In !!!");
		}

		System.getProperties().put("java.protocol.handler.pkgs","com.sun.net.ssl.internal.www.protocol");
		java.security.Security.addProvider(new com.sun.net.ssl.internal.ssl.Provider());

		URL url = new URL("https://lc3.law13.hotmail.passport.com/cgi-bin/dologin");
		HttpURLConnection huc = (HttpURLConnection) url.openConnection();

		huc.setDoOutput(true);
		huc.setRequestMethod("POST");
		huc.setRequestProperty("User-Agent","Mozilla/4.7 [en] (Win98; I)");

		StringBuffer sb = new StringBuffer();

		sb.append("login="); sb.append(URLEncoder.encode(user));
		sb.append("&domain="); sb.append(URLEncoder.encode("hotmail.com"));
		sb.append("&svc="); sb.append(URLEncoder.encode("mail"));
		sb.append("&RemoteDAPost="); sb.append(URLEncoder.encode("https://login.msnia.passport.com/ppsecure/post.asp"));
		sb.append("&passwd="); sb.append(URLEncoder.encode(pw));
		sb.append("&enter="); sb.append(URLEncoder.encode("Sign In"));
		sb.append("&sec="); sb.append(URLEncoder.encode("no"));
		sb.append("&curmbox="); sb.append(URLEncoder.encode("ACTIVE"));
		sb.append("&js="); sb.append(URLEncoder.encode("yes"));
		sb.append("&_lang="); sb.append(URLEncoder.encode("EN"));
		sb.append("&beta="); sb.append(URLEncoder.encode(""));
		sb.append("&ishotmail="); sb.append(URLEncoder.encode("1"));
		sb.append("&mspp_shared="); sb.append(URLEncoder.encode(""));
		sb.append("&id="); sb.append(URLEncoder.encode("2"));
		sb.append("&fs="); sb.append(URLEncoder.encode("1"));
		sb.append("&cb="); sb.append(URLEncoder.encode("_lang%3dEN"));
		sb.append("&ct="); sb.append(URLEncoder.encode("1011886321"));
		sb.append("\r\n\r\n");

		OutputStream os = huc.getOutputStream();
		os.write(sb.toString().getBytes("US-ASCII"));
		os.close();

		//System.out.println("Written POST = " + sb);

		HTTPRedirectHandler hrh = new HTTPRedirectHandler(huc);
		hrh.connect();

		huc = hrh.getConnection();

		BufferedReader br = new BufferedReader(new InputStreamReader(huc.getInputStream()));
		String line;
		StringBuffer buffer = new StringBuffer();
		int iLineCount = 0;
		boolean bIsInterim = false;

		//System.out.println("After Redirections:-\n");
		while((line = br.readLine()) != null)
		{
			iLineCount++;
			//System.out.println(line);
			if("<title>Hotmail</title>".equals(line))
			{
				bIsInterim = true;
			}

			if(iLineCount > 5 && !bIsInterim)
			{
				break;
			}

			buffer.append(line);
			buffer.append("\n");
		}

		br.close();
		huc.disconnect();

		if(!bIsInterim)
		{
			return(false);
		}

		cj = hrh.getCookieJar();

		boolean bIsHome = false;
		StringTokenizer st = new StringTokenizer(buffer.toString(), ";\"");
		String homeUrl = "EMPTY";

		while(st.hasMoreTokens())
		{
			line = st.nextToken();
			if(line.trim().startsWith("url=http://"))
			{
				homeUrl = line.trim().substring(4);
				break;
			}
		}

		if("EMPTY".equals(homeUrl))
		{
			return(false);
		}

		//System.out.println("Home URL = " + homeUrl);

		aValue = homeUrl.substring(homeUrl.indexOf("&a=")+3,homeUrl.indexOf("&f="));
		//System.out.println("aValue=" + aValue);
		url = new URL(homeUrl);
		huc = (HttpURLConnection) url.openConnection();

		huc.setRequestProperty("User-Agent","Mozilla/4.7 [en] (Win98; I)");

		hrh = new HTTPRedirectHandler(huc);
		hrh.setCookieJar(cj);
		hrh.connect();

		huc = hrh.getConnection();

		br = new BufferedReader(new InputStreamReader(huc.getInputStream()));
		iLineCount = 0;
		//buffer.delete(0,buffer.length());

		//System.out.println("After Second Round of Redirections:-\n");
		while((line = br.readLine()) != null)
		{
			iLineCount++;
			//System.out.println(line);
			if("<title>Hotmail Home</title>".equals(line))
			{
				bIsHome = true;
			}

			if(iLineCount > 5 && !bIsHome)
			{
				break;
			}

			//buffer.append(line);
			//buffer.append("\n");
		}

		cj.addAll(hrh.getCookieJar());
		mainUrl = hrh.getConnection().getURL();
		br.close();
		huc.disconnect();

		return(bLoggedIn = bIsHome);
	}

	public Vector getNewMessages() throws Exception
	{
		if(!bLoggedIn)
		{
			throw new IllegalStateException("Must be logged in.");
		}

		URL url = new URL(mainUrl, "/cgi-bin/HoTMaiL?curmbox=F000000001&a=" + aValue);
		HttpURLConnection huc = (HttpURLConnection) url.openConnection();

		//System.out.println("InboxURL = " + url);
		//System.out.println("MainURL = " + mainUrl);
		huc.setRequestProperty("User-Agent","Mozilla/4.7 [en] (Win98; I)");

		HTTPRedirectHandler hrh = new HTTPRedirectHandler(huc);
		hrh.setCookieJar(cj);
		hrh.connect();

		BufferedReader br = new BufferedReader(new InputStreamReader(hrh.getInputStream()));
		String line;
		StringBuffer buffer = new StringBuffer();
		int iLineCount = 0;
		boolean bIsInbox = false;

		while((line = br.readLine()) != null)
		{
			iLineCount++;
			//System.out.println(line);
			if("<title>Hotmail Inbox</title>".equals(line))
			{
				bIsInbox = true;
			}

			if(iLineCount > 5 && !bIsInbox)
			{
				break;
			}

			buffer.append(line);
			buffer.append("\n");
		}

		br.close();

		if(!bIsInbox)
		{
			throw new IOException("Could not retrieve Inbox");
		}

		Reader xhtml = new ConvertBadHTMLToGood(new StringReader(buffer.toString())).doConvert();

		return(extractNewMessages(xhtml));
	}

	static Vector extractNewMessages(Reader xhtml) throws Exception
	{
		Vector newMsgs = new Vector();

		Document doc = getDOMDocument(xhtml);

		NodeList nl = doc.getElementsByTagName("table");

		Node n = null;
		Element e = null;

		int ntype = 0;

		for(int i=0; i < nl.getLength(); i++)
		{
			n = nl.item(i);
			ntype = n.getNodeType();

			if(ntype == Node.ELEMENT_NODE)
			{
				e = (Element) n;
				String idVal = e.getAttribute("id");

				if("MsgTable".equalsIgnoreCase(idVal))
				{
					NodeList rowList = e.getElementsByTagName("tr");
					HMMessage hm;
					String from = null, subject = null, date = null;
					boolean bIsNew = false;

					for(int j=1; j < rowList.getLength(); j++)
					{
						NodeList columnList = ((Element) rowList.item(j)).getElementsByTagName("td");
						bIsNew = false;

						for(int k=0; k < columnList.getLength(); k++)
						{
							Node nod = columnList.item(k);
							switch(k)
							{
								case 0:
									if(nod.hasChildNodes())
									{
										Element img = null;
										if(nod.getFirstChild().getNodeType() == Node.ELEMENT_NODE)
										{
											img = (Element) nod.getFirstChild();
											String tagName = img.getTagName();

											if(tagName.equalsIgnoreCase("img"))
											{
												String imgSrc = img.getAttribute("src");

												if(imgSrc.endsWith("newmail.gif"))
												{
													bIsNew = true;
												}
											}
										}
									}
									break;
								case 2:
									NodeList l = ((Element) nod).getElementsByTagName("a");

									Element anch = (Element) l.item(0);
									Text text = (Text) anch.getFirstChild();
									from = text.getData().trim();
									break;
								case 3:
									Text t = (Text) nod.getFirstChild();
									subject = t.getData();
									break;
								case 4:
									Text tx = (Text) nod.getFirstChild();
									date = tx.getData();
									break;
							}

							if(!bIsNew)
							{
								break;
							}
						}

						if(bIsNew)
						{
							hm = new HMMessage(from,subject,date);
							newMsgs.add(hm);
						}
					}
				}
			}
		}

		if(newMsgs.size() > 0)
		{
			return(newMsgs);
		}

		return(null);
	}

	static Document getDOMDocument(Reader r) throws Exception
	{
        // Step 1: create a DocumentBuilderFactory and configure it
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();

        // Optional: set various configuration options
        dbf.setValidating(false);
        dbf.setIgnoringComments(true);
        dbf.setIgnoringElementContentWhitespace(true);
        dbf.setCoalescing(true);
        // The opposite of creating entity ref nodes is expanding them inline
        dbf.setExpandEntityReferences(false);

        // At this point the DocumentBuilderFactory instance can be saved
        // and reused to create any number of DocumentBuilder instances
        // with the same configuration options.

        // Step 2: create a DocumentBuilder that satisfies the constraints
        // specified by the DocumentBuilderFactory
        DocumentBuilder db = null;
        db = dbf.newDocumentBuilder();

        // Step 3: parse the input file
        Document doc = null;
        doc = db.parse(new InputSource(r));

		return(doc);
	}
}